---
title: RTCDataChannel.readyState
slug: Web/API/RTCDataChannel/readyState
tags:
  - Experimental
  - Property
  - RTCDataChannel
  - Read-only
  - Reference
  - WebRTC
  - readyState
---
<div>{{APIRef("WebRTC")}}{{SeeCompatTable}}</div>

<p><span class="seoSummary">The read-only <code>RTCDataChannel</code> property <code><strong>readyState</strong></code> returns an enum of type <code>RTCDataChannelState</code> which indicates the state of the data channel's underlying data connection.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: js">var <em>state</em> = <em>aDataChannel</em>.readyState;
</pre>

<h3 id="Values">Values</h3>

<p>A string which is one of the values in the {{anch("RTCDataChannelState enum", "RTCDataChannelState")}} enum, indicating the current state of the underlying data transport.</p>

<h4 id="RTCDataChannelState_enum">RTCDataChannelState enum</h4>

<p>The <code>RTCDataChannelState</code> enum defines string constants which reflect the current status of the {{domxref("RTCDataChannel")}}'s underlying data connection.</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Constant</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>"connecting"</code></td>
   <td>The user agent (browser) is in the process of creating the underlying data transport; that is, whatever network level connection is used to link the two peers together is in the process of being set up. This is the state of a new {{domxref("RTCDataChannel")}} after being created by {{domxref("RTCPeerConnection.createDataChannel()")}} (on the peer which started the connection process).</td>
  </tr>
  <tr>
   <td><code>"open"</code></td>
   <td>The underlying data transport has been established and data can be transferred bidirectionally across it. This is the default state of a new {{domxref("RTCDataChannel")}} created by the WebRTC layer when the remote peer created the channel and delivered to the site or app in a {{event("datachannel")}} event of type {{domxref("RTCDataChannelEvent")}}.</td>
  </tr>
  <tr>
   <td><code>"closing"</code></td>
   <td>The process of closing the underlying data transport has begun. It is no longer possible to queue new messages to be sent, but previously queued messages may still be send or received before entering the <code>"closed"</code> state.</td>
  </tr>
  <tr>
   <td><code>"closed"</code></td>
   <td>The underlying data transport has closed, or the attempt to make the connection failed.</td>
  </tr>
 </tbody>
</table>

<h2 id="Example">Example</h2>

<pre class="brush: js">var dataChannel = peerConnection.createDataChannel("File Transfer");
var sendQueue = [];

function sendMessage(msg) {
  switch(dataChannel.readyState) {
    case "connecting":
      console.log("Connection not open; queueing: " + msg);
      sendQueue.push(msg);
      break;
    case "open":
      sendQueue.forEach((msg) =&gt; dataChannel.send(msg));
      break;
    case "closing":
      console.log("Attempted to send message while closing: " + msg);
      break;
    case "closed":
      console.log("Error! Attempt to send while connection closed.");
      break;
  }
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('WebRTC 1.0', '#dom-datachannel-readystate', 'RTCDataChannel.readyState') }}</td>
   <td>{{ Spec2('WebRTC 1.0') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCDataChannel.readyState")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/Guide/API/WebRTC">WebRTC</a></li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Using_data_channels">Using WebRTC data channels</a></li>
 <li>{{domxref("RTCDataChannel")}}</li>
 <li>{{domxref("RTCPeerConnection.createDataChannel()")}}</li>
</ul>
